//-*- coding:utf-8; mode:ats; indent-tabs-mode:nil; c-basic-offset:2; -*-

// ===========================================================================

fun main0_1 () = {
  val out = fileref_open_exn ("test-01.txt", file_mode_w)
  val () = fprint_string (out, "Hello, world!\n")
  val () = fileref_close (out)
  val () = print ("Hello, world!\n")
}

// ===========================================================================

fun main0_2 () = {
  val out = fileref_open_exn ("test-01.txt", file_mode_w)
  val () = fprint (out, "Hello, world!\n") // Use the overload `fprint`.
  val () = fileref_close (out)
  val () = print ("Hello, world!\n")
}

// ===========================================================================

fun message_3 (): string = "Hello, world!\n" // Function for same messages.

fun main0_3 () = {
  val out = fileref_open_exn ("test-01.txt", file_mode_w)
  val () = fprint (out, message_3 ())
  val () = fileref_close (out)
  val () = print (message_3 ())
}

// ===========================================================================

extern fun message_4 (): string // Use a declaration/implementation paire.
implement message_4 () = "Hello, world!\n"

fun main0_4 () = {
  val out = fileref_open_exn ("test-01.txt", file_mode_w)
  val () = fprint (out, message_4 ())
  val () = fileref_close (out)
  val () = print (message_4 ())
}

// ===========================================================================

extern fun message_5 (): string
implement message_5 () = "Hello, world!\n"
#define FILE_NAME_5 "test-01.txt" // A macro for the file name.

fun main0_5 () int = {
  val out = fileref_open_exn (FILE_NAME_5, file_mode_w)
  val () = fprint (out, message_5 ())
  val () = fileref_close (out)
  val () = print (message_5 ())
}

// ===========================================================================

extern fun message_6 (): string
implement message_6 () = "Hello, world!\n"
#define FILE_NAME_6 "test-01.txt"

fun main0_6 () = {
  val out = fileref_open_exn (FILE_NAME_6, file_mode_w)
  val () =
    begin // Use a `begin/end` block for the None expressions.
      fprint (out, message_6 ()); // Note the semicolon.
      fileref_close (out);
      print (message_6 ())
    end
}

// ===========================================================================

implement main0 () = begin // `implement` matched by an `extern`.
  main0_6 ()
end (* [main0] *)
